diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index 07c381ba6..c0298615b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.dynamictexture;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.world.Dimension;
 
 public class DynamicTextureWaterStill extends DynamicTexture {
 	
@@ -76,11 +77,24 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 			}
 
 			float var13 = bright * bright;
-			int r = (int) (32.0F + var13 * 32.0F);
-			int g = (int) (50.0F + var13 * 64.0F);
-			int b = 255;
+
+			int colorMax = 255;
+			int colorMid = (int) (50.0F + var13 * 64.0F);
+			int colorMin = (int) (32.0F + var13 * 32.0F);
+
+			int r = colorMin;
+			int g = colorMid;
+			int b = colorMax;
 			int a = (int) (146.0F + var13 * 50.0F);
 
+			if (this.mc.currentWorld != null && this.mc.currentWorld.dimension == Dimension.NETHER) {
+				float brightness = 0.75F;
+				r = (int) (255 * brightness);
+				g = (int) (colorMin * brightness);
+				b = (int) (colorMin * brightness);
+				a = (int) (225.0F + var13 * 25.0F);
+			}
+
 			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
 				r = g = b = (r + g + b) / 3;
 			}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
index 96dc05415..1cd8084a9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
@@ -17,81 +17,110 @@ public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
     }
 
     @Override
-    public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityLightning lightning, double x, double y, double z,
-                       float yaw, float partialTick) {
+    public void render(
+        final @NotNull TessellatorGeneral tessellator,
+        final @NotNull EntityLightning lightning,
+        final double x, final double y, final double z,
+        final float yaw, final float partialTick
+    ) {
         GLRenderer.pushFrame();
+
         GLRenderer.setShader(Shaders.COLOR_WORLD);
         GLRenderer.globalSetLightEnabled(false);
+
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE);
-        double[] ad = new double[8];
-        double[] ad1 = new double[8];
-        double d3 = 0.0D;
-        double d4 = 0.0D;
-        Random random = new Random(lightning.seed);
-        for (int j = 7; j >= 0; j--) {
-            ad[j] = d3;
-            ad1[j] = d4;
-            d3 += random.nextInt(11) - 5;
-            d4 += random.nextInt(11) - 5;
+
+        final double @NotNull [] xOffs = new double[8];
+        final double @NotNull [] zOffs = new double[8];
+        double xOff = 0.0D;
+        double zOff = 0.0D;
+        final @NotNull Random random = new Random(lightning.seed);
+
+        for (int h = 7; h >= 0; h--) {
+            xOffs[h] = xOff;
+            zOffs[h] = zOff;
+            xOff += random.nextInt(11) - 5;
+            zOff += random.nextInt(11) - 5;
         }
 
-        for (int i = 0; i < 4; i++) {
+        // r = radius
+        for (int r = 0; r < 4; r++) {
             random.setSeed(lightning.seed);
-            for (int k = 0; k < 3; k++) {
-                int l = 7;
-                int i1 = 0;
-                if (k > 0) {
-                    l = 7 - k;
-                }
-                if (k > 0) {
-                    i1 = l - 2;
+
+            // p = beam number
+            for (int p = 0; p < 3; p++) {
+                int hs = 7;
+                int ht = 0;
+                if (p > 0) {
+                    hs = 7 - p;
+                    ht = hs - 2;
                 }
-                double d5 = ad[l] - d3;
-                double d6 = ad1[l] - d4;
-                for (int j1 = l; j1 >= i1; j1--) {
-                    double d7 = d5;
-                    double d8 = d6;
-                    if (k == 0) {
-                        d5 += random.nextInt(11) - 5;
-                        d6 += random.nextInt(11) - 5;
+
+                double xo0 = xOffs[hs] - xOff;
+                double zo0 = zOffs[hs] - zOff;
+
+                // h = segment
+                for (int h = hs; h >= ht; h--) {
+                    final double xo1 = xo0;
+                    final double zo1 = zo0;
+                    if (p == 0) {
+                        xo0 += random.nextInt(11) - 5;
+                        zo0 += random.nextInt(11) - 5;
                     } else {
-                        d5 += random.nextInt(31) - 15;
-                        d6 += random.nextInt(31) - 15;
+                        xo0 += random.nextInt(31) - 15;
+                        zo0 += random.nextInt(31) - 15;
                     }
+
                     tessellator.startDrawing(DrawMode.TRIANGLE_STRIP);
-                    float f2 = 0.5F;
-                    tessellator.setColor4f(0.9F * f2, 0.9F * f2, f2, 0.3F);
-                    double d9 = 0.1D + (double) i * 0.2D;
-                    if (k == 0) {
-                        d9 *= (double) j1 * 0.1D + 1.0D;
+                    final float br = 0.5F;
+                    tessellator.setColor4f(lightning.r * br, lightning.g * br, lightning.b * br, 0.3F);
+
+                    double rr1 = 0.1D + (double) r * 0.2D;
+                    if (p == 0) {
+                        rr1 *= (double) h * 0.1D + 1.0D;
                     }
-                    double d10 = 0.1D + (double) i * 0.2D;
-                    if (k == 0) {
-                        d10 *= (double) (j1 - 1) * 0.1D + 1.0D;
+
+                    double rr2 = 0.1D + (double) r * 0.2D;
+                    if (p == 0) {
+                        rr2 *= (double) (h - 1) * 0.1D + 1.0D;
                     }
-                    for (int k1 = 0; k1 < 5; k1++) {
-                        double d11 = (x + 0.5D) - d9;
-                        double d12 = (z + 0.5D) - d9;
-                        if (k1 == 1 || k1 == 2) {
-                            d11 += d9 * 2D;
+
+                    for (int s = 0; s < 5; s++) {
+                        double xos1 = 0.5D - rr1;
+                        double zos1 = 0.5D - rr1;
+                        if (s == 1 || s == 2) {
+                            xos1 += rr1 * 2D;
                         }
-                        if (k1 == 2 || k1 == 3) {
-                            d12 += d9 * 2D;
+                        if (s == 2 || s == 3) {
+                            zos1 += rr1 * 2D;
                         }
-                        double d13 = (x + 0.5D) - d10;
-                        double d14 = (z + 0.5D) - d10;
-                        if (k1 == 1 || k1 == 2) {
-                            d13 += d10 * 2D;
+
+                        double xos2 = 0.5D - rr2;
+                        double zos2 = 0.5D - rr2;
+                        if (s == 1 || s == 2) {
+                            xos2 += rr2 * 2D;
+                        }
+                        if (s == 2 || s == 3) {
+                            zos2 += rr2 * 2D;
                         }
-                        if (k1 == 2 || k1 == 3) {
-                            d14 += d10 * 2D;
+
+                        if (lightning.flipped) {
+                            tessellator.addVertex(xos2 + xo0, ((h - hs) * 16), zos2 + zo0);
+                            tessellator.addVertex(xos1 + xo1, ((h - hs + 1) * 16), zos1 + zo1);
+                        } else {
+                            tessellator.addVertex(xos2 + xo0, (h * 16), zos2 + zo0);
+                            tessellator.addVertex(xos1 + xo1, ((h + 1) * 16), zos1 + zo1);
                         }
-                        tessellator.addVertex(d13 + d5, y + (double) (j1 * 16), d14 + d6);
-                        tessellator.addVertex(d11 + d7, y + (double) ((j1 + 1) * 16), d12 + d8);
                     }
 
+                    GLRenderer.pushFrame();
+                    GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+                    GLRenderer.modelM4f().rotate(lightning.yaw, 0.0f, 1.0f, 0.0f);
+                    GLRenderer.modelM4f().rotate(lightning.pitch, 1.0f, 0.0f, 0.0f);
+                    GLRenderer.modelM4f().scale(lightning.scale, lightning.scale, lightning.scale);
                     tessellator.draw();
+                    GLRenderer.popFrame();
                 }
 
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index f06b4670c..d134b8853 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -424,6 +424,8 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new ItemModelStandard(Items.FOOD_VENISON_RAW, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_VENISON_COOKED, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.RUBYGLASS_CRYSTAL_CRACKED, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.RUBYGLASS_CRYSTAL_PURE, "minecraft"));
 
         addDispatch(new ItemModelStandard(Items.DOUGH, "minecraft"));
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index 69a295c2c..ec06a71e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -232,5 +232,12 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
                 return new ParticleAsh(world, x, y, z, 0, 0, 0);
             }
         });
+
+        addDispatch("ventsmoke", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleVentSmoke(world, x, y, z, motionX, motionY, motionX, 2.5f, data);
+            }
+        });
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
new file mode 100644
index 000000000..05518fc88
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
@@ -0,0 +1,75 @@
+package net.minecraft.client.render.particle;
+
+import net.minecraft.client.render.tessellator.TessellatorParticle;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+public class ParticleVentSmoke extends Particle {
+    private final float oSize;
+
+    public ParticleVentSmoke(World world, double x, double y, double z, double xa, double ya, double za, float scale, int data) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd *= 0.1D;
+        this.yd *= 0.1D;
+        this.zd *= 0.1D;
+        this.xd += xa;
+        this.yd += ya;
+        this.zd += za;
+        if (data == 1) {
+            this.rCol = this.gCol = this.bCol = (float) (1.0 - (Math.random() * 0.2));
+        } else {
+            this.rCol = this.gCol = this.bCol = (float) (Math.random() * 0.3D);
+        }
+        this.size *= 1F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = (int) (20D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime *= (int) scale;
+        this.noPhysics = false;
+    }
+
+    @Override
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
+        float size = ((this.age + partialTick) / this.lifetime) * 32F;
+        if (size < 0.0F) {
+            size = 0.0F;
+        }
+        if (size > 1.0F) {
+            size = 1.0F;
+        }
+        this.size = this.oSize * size;
+        super.render(t, partialTick);
+    }
+
+    @Override
+    public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        int val = (14 - ((this.age * 14) / this.lifetime));
+        if(val > 7)
+            val = 7;
+        if (val >= 0) {
+            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
+        } else {
+            this.tex = null;
+        }
+        this.yd += 0.004D;
+        this.move(this.xd, this.yd, this.zd);
+        if (this.y == this.yo) {
+            this.xd *= 1.1D;
+            this.zd *= 1.1D;
+        }
+        this.xd *= 0.96D;
+        this.yd *= 0.96D;
+        this.zd *= 0.96D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
index 904c206ca..d9e3c6d3a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -7,7 +7,6 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
-import net.minecraft.core.world.biome.provider.BiomeProviderNether;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
@@ -51,14 +50,15 @@ public class WorldTypeFXNether extends WorldTypeFX {
         return new Vector3f(r, g, b);
     }
 
+
     @Override
     public void playerAnimationTick(@NotNull World world, @NotNull Player player) {
         final int radius = 12;
 
         TilePos tilePos = new TilePos(player);
         Biome localBiome = world.getBlockBiome(tilePos);
-        if (localBiome == Biomes.NETHER_ASH_PLAINS || localBiome == Biomes.NETHER_BONEYARD) {
-            for (int i = 0; i < 5; i++) {
+        if (localBiome == Biomes.NETHER_OLD_WORLD) {
+            for (int i = 0; i < 3; i++) {
                 double rx = (player.x - radius) + (world.rand.nextDouble() * radius * 2);
                 double ry = (player.y - radius) + (world.rand.nextDouble() * radius * 2);
                 double rz = (player.z - radius) + (world.rand.nextDouble() * radius * 2);
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.emiss.png.mcmeta
new file mode 100644
index 000000000..394983571
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.emiss.png.mcmeta
@@ -0,0 +1,19 @@
+{
+    "animation": {
+        "frametime": 1,
+        "frames": [
+            0,
+            1,
+            2,
+            3,
+            4,
+            5,
+            6,
+            7,
+            8,
+            9,
+            10,
+            11
+        ]
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.emiss.png.mcmeta
new file mode 100644
index 000000000..394983571
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.emiss.png.mcmeta
@@ -0,0 +1,19 @@
+{
+    "animation": {
+        "frametime": 1,
+        "frames": [
+            0,
+            1,
+            2,
+            3,
+            4,
+            5,
+            6,
+            7,
+            8,
+            9,
+            10,
+            11
+        ]
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonepile.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonepile.java
new file mode 100644
index 000000000..00bc1c4fc
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonepile.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicBonepile
+    extends BlockLogicFlower {
+
+    public BlockLogicBonepile(final @NotNull Block<?> block) {
+        super(block);
+        final float f = 0.4F;
+        this.setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
+    }
+
+    @Override
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return this.mayPlaceOn(world.getBlockType(tilePos.down(new TilePos())));
+    }
+
+    @Override
+    public boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block.isSolidRender();
+    }
+
+    @Override
+    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int meta, final @Nullable TileEntity tileEntity) {
+        final int quantity = world.rand.nextInt(3) + 1;
+
+        return switch (dropCause) {
+            case SILK_TOUCH, PICK_BLOCK -> new ItemStack[] { new ItemStack(this) };
+            default -> {
+                if (quantity == 0 || world.rand.nextInt(8) != 0) yield null;
+                yield new ItemStack[] { new ItemStack(Items.BONE, quantity) };
+            }
+        };
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
similarity index 95%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
index f5d14676d..33229309b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
@@ -16,8 +16,8 @@ import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicNetherrackIgneous extends BlockLogic {
-    public BlockLogicNetherrackIgneous(@NotNull Block<?> block) {
+public class BlockLogicMagma extends BlockLogic {
+    public BlockLogicMagma(@NotNull Block<?> block) {
         super(block, Materials.NETHERRACK);
         block.setTicking(true);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
new file mode 100644
index 000000000..0f5b1f45c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
@@ -0,0 +1,109 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.entity.EntityLightning;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class BlockLogicRubyglass extends BlockLogic
+{
+
+    public BlockLogicRubyglass(Block<?> block)
+    {
+        super(block, Materials.STONE);
+        block.setTicking(true);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int meta, TileEntity tileEntity)
+    {
+        switch (dropCause)
+        {
+            case PICK_BLOCK:
+            case SILK_TOUCH:
+                return new ItemStack[] { new ItemStack(this) };
+            default:
+                return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_CRACKED, world.rand.nextInt(3)) };
+        }
+    }
+
+    @Override
+    public float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return 0.0f;
+    }
+
+    @Override
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+        if (world.isClientSide) {
+            return;
+        }
+
+        if (world.dimension != Dimension.NETHER) {
+            return;
+        }
+
+        if (rand.nextInt(10) == 0) {
+            final int dir = rand.nextInt(6);
+            final @NotNull Direction direction = Direction.getDirectionById(dir);
+
+            final @NotNull TilePos checkPos = tilePos.add(direction, new TilePos());
+            final @NotNull Block<?> checkBlock = world.getBlockType(checkPos);
+            if (checkBlock == Blocks.AIR) {
+                final float pitch, yaw;
+                switch (dir) {
+                    case 0 -> { // Down
+                        pitch = 0.0f;
+                        yaw = 0.0f;
+                    }
+                    case 1 -> { // Up
+                        pitch = MathHelper.PI;
+                        yaw = 0.0f;
+                    }
+                    case 2 -> { // North
+                        pitch = MathHelper.PI / 2.0f;
+                        yaw = 0.0f;
+                    }
+                    case 3 -> { // South
+                        pitch = -MathHelper.PI / 2.0f;
+                        yaw = 0.0f;
+                    }
+                    case 4 -> { // West
+                        pitch = MathHelper.PI / 2.0f;
+                        yaw = MathHelper.PI / 2.0f;
+                    }
+                    case 5 -> { // East
+                        pitch = MathHelper.PI / 2.0f;
+                        yaw = -MathHelper.PI / 2.0f;
+                    }
+                    default -> {
+                        return;
+                    }
+                }
+
+                final @NotNull EntityLightning lightning = new EntityLightning(world, checkPos.x, checkPos.y, checkPos.z);
+                lightning.r = 1.0f;
+                lightning.g = 0.3f;
+                lightning.b = 0.1f;
+                lightning.pitch = pitch;
+                lightning.yaw = yaw;
+                lightning.silent = true;
+                lightning.scale = 0.125f;
+                lightning.flipped = true;
+
+                world.addWeatherEffect(lightning);
+            }
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
new file mode 100644
index 000000000..5535bbe5d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
@@ -0,0 +1,156 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+
+import java.util.Random;
+
+public class BlockLogicRubyglassCrop extends BlockLogic {
+    public BlockLogicRubyglassCrop(Block<?> block) {
+        super(block, Materials.PLANT);
+        block.setTicking(true);
+    }
+
+    public static final int MASK_GROWTH_STAGE = 0b0000_0011;
+
+    public static final int MAX_GROWTH_STATE = 3;
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public @Nullable AABBd getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return null;
+    }
+
+    public boolean mayPlaceOnBlockAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return world.getBlockType(tilePos) == Blocks.COBBLE_NETHERRACK || world.getBlockType(tilePos) == Blocks.COBBLE_NETHERRACK_CRYSTALLINE;
+    }
+
+    @Override
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        final @NotNull TilePos temp = new TilePos();
+        return mayPlaceOnBlockAt(world, tilePos.down(temp));
+    }
+
+    @Override
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        final @NotNull TilePos temp = new TilePos();
+        return mayPlaceOnBlockAt(world, tilePos.down(temp));
+    }
+
+    public boolean isValidGrowthConditions(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        TilePos cursor = new TilePos(tilePos.x(), tilePos.y() + 1, tilePos.z());
+        TilePos waterCursor = new TilePos(tilePos.x(), tilePos.y() + 2, tilePos.z());
+
+        boolean isAir = world.isAirBlock(cursor);
+
+        for (int iy = 1; iy < 8 && iy < world.getWorldType().getMaxY(world)-1; iy++){
+            cursor.set(cursor.x, ++cursor.y, cursor.z);
+            waterCursor.set(waterCursor.x, ++waterCursor.y, waterCursor.z);
+
+            boolean solidBlockFound = world.isBlockNormalCube(cursor);
+
+            if(isAir){
+                if(solidBlockFound) {
+                    return world.getBlockType(waterCursor).hasTag(BlockTags.IS_WATER);
+                } else {
+                    isAir = world.isAirBlock(cursor);
+                }
+            } else {
+                return false;
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        if(!canStay(world, tilePos))
+        {
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
+        }
+    }
+
+    @Override
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+        super.updateTick(world, tilePos, rand, isRandomTick);
+        if (isValidGrowthConditions(world, tilePos)) {
+
+            TilePos blockBelow = new TilePos();
+            tilePos.down(blockBelow);
+
+            if(world.getBlockType(blockBelow) == Blocks.COBBLE_NETHERRACK){
+                world.setBlockTypeNotify(blockBelow, Blocks.COBBLE_NETHERRACK_CRYSTALLINE);
+            }
+
+            final int stage = metaToGrowthStage(world.getBlockData(tilePos));
+
+            if (stage < MAX_GROWTH_STATE) {
+                float growthRate = getGrowthRate(world, tilePos);
+                if(growthRate > 0.0F) {
+                    if (rand.nextInt((int) (100 / growthRate)) == 0) {
+                        world.setBlockDataNotify(tilePos, stage + 1);
+                    }
+                }
+            }
+        }
+    }
+
+    private float getGrowthRate (final @NotNull World world, final @NotNull TilePosc tilePos) {
+        float growthRate = 0F;
+        if(world.dimension == Dimension.NETHER) {
+            growthRate = 5F;
+        }
+        else if(isLavaNearby(world, tilePos)) {
+            growthRate = 3.5F;
+        }
+        return growthRate;
+    }
+
+    public boolean isLavaNearby(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos cursor = new TilePos();
+        TilePos queryPos = new TilePos();
+        tilePos.down(cursor);
+        return
+                world.getBlockType(cursor.east(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+                        world.getBlockType(cursor.west(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+                        world.getBlockType(cursor.down(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+                        world.getBlockType(cursor.south(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+                        world.getBlockType(cursor.north(queryPos)).hasTag(BlockTags.IS_LAVA);
+    }
+
+    @Override
+    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
+        if (data != MAX_GROWTH_STATE) {
+            return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_CRACKED) };
+        } else {
+            return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_PURE) };
+        }
+    }
+
+
+    public static int metaToGrowthStage(int meta) {
+        return meta & MASK_GROWTH_STAGE;
+    }
+
+}
